//varyingϐ(_VF[_󂯎f[^Ő錾)
varying vec3 normal;
varying vec4 vertexPos;
uniform sampler2D toonTex;	// gD[peNX`Zbgjbgԍ
varying vec4 localPos;		// gD[eNX`̓WJpɕϊOWl󂯂

//tOg
void main(void)
{
	////  ambienťvZ  ////
	vec4 ambient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;

	////  diffusevZ  ////
	vec3 N = normalize(normal);
	vec3 L = normalize(gl_LightSource[0].position.xyz);
	float NdotL = max(0.0, dot(N, L));
	// ϒlPxlƂăeNX`W̏cɁA
	// fxW̎QƍWɎgƂŁAhp^[WJ
	NdotL = texture2D(toonTex, vec2(localPos.x*0.2, NdotL)).r;
	vec4 diffuse = max(0.0, NdotL) * gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse;

	////  specularvZ(Blinñfgp)  ////
	vec3 V = -normalize(vertexPos.xyz);
	vec3 H = normalize(V + L);
	float NdotH = dot(N, H);
	float k_specular = pow(max(0.0, NdotH), gl_FrontMaterial.shininess);
	vec4 specular = k_specular * gl_LightSource[0].specular * gl_FrontMaterial.specular;

	gl_FragColor = ambient + diffuse + specular;
}
